#include<../vector>
#include<iostream>
#include<LEDA/numbers/integer.h>
#include<LEDA/numbers/integer_matrix.h>

using namespace std;
using namespace leda;

class sepa {
public:
  int *s;
  int c;
  void set(int x){ s = new int[x]; c = 0;}
  void del(){ delete [] s; }
}; 

void sp(vector<sepa>&,int);
void quickSort(vector<sepa>&,int,int);
void exchangeOfValues(vector<sepa>&,int,int);
int cup(int*,int*,int);
int min(int, int);

int main(){
  
  int r = 5; //Zp[^̐̌vŹAr13E
  int i;
  vector<sepa> v;

  sp(v,r);

  int size;

  size = v.size();

  cout << size << endl;
  cout << v.max_size() << endl;

  quickSort(v,0,size-1);
  
  int j;

  for(i = 0; i < size; i++){
    for(j = 0; j < r; j++)
      cout << v[i].s[j];
    cout << ' ' << v[i].c << endl;
  }

  integer_matrix M(size);
  
  for(i = 0; i < size; i++)
    for(j = 0; j < size; j++)
      M(i,j) = cup(v[i].s,v[j].s,r);
  
  for(i = 0; i < size; i++)
    {
      for(j = 0; j < size; j++)
	cout << M(i,j) << ' ';
      cout << endl;
    }
  
  for(i = 0; i < size; i++)
    v[i].del();

  return 0;
}

void sp(vector<sepa> &v, int r) {
  int *sp;
  int i;
  
  sp = new int[r];
  
  for(i = 0; i < r; i++)
    sp[i]=i;
  
  int j, k, c;
  while(1){
    c = 0;
    sepa ob;
    ob.set(r);
    
    for(i = 0; i < r; i++){
      ob.s[i]=sp[i];
      if(sp[i] > c)
	c = sp[i];
    }

    ob.c = c+1;
    
    v.push_back(ob);
    
    i = r-1;
    
    while(i){
      if(sp[i]!=0)
	break;
      i--;
    }
    if(i==0)
      break;
    
    sp[i]--;
    if(i!=r-1){
      k = 0;
      for(j=0;j<=i;j++)
	if(sp[j]>k)
	  k=sp[j];
      for(;j<r;j++){
	sp[j]=k+1;
	k++;
      }
    }
  }

  return;
}

void quickSort(vector<sepa> &v, int first_index , int last_index) {
  int i = first_index, j = last_index ; 
  int key = (v[(first_index + last_index) / 2]).c;
  
  while(1) {
    while (v[i].c < key) i++;
    while (v[j].c > key) j--;
    if (i >= j) break;
    exchangeOfValues(v,i,j);
    i++; j--;
  }
  if (first_index < i - 1) quickSort(v, first_index , i - 1);
  if (last_index > j + 1) quickSort(v, j + 1 , last_index);
  return;
}

void exchangeOfValues(vector<sepa> &v,int x , int y) {
  sepa tmp;
  tmp = v[x]; v[x] = v[y] ; v[y] = tmp;
  return;
}


int cup(int *a, int *b,int r) {
  
  int *s;
  int i, j;
  
  s = new int[r];

  for(i = 0; i < r; i++)
    s[i] = r;

  for(i = 0; i < r; i++)
    for(j = i+1; j < r; j++)
      if(a[i] == a[j] || b[i] == b[j]){
	s[i]=min(a[i],min(b[i],min(s[i],s[j])));
	s[j]=s[i];
      }

  int k = 0;

  for(i = 0; i < r; i++) {
    if(s[i] == r){
      s[i] = k;
      k++;
    }
    else if(s[i] >= k)
      k = s[i]+1;
  }

  return k;
}

int min(int a, int b){

  if(a <= b)
    return a;
  else return b;

}





